/*****************************

This is an alpha release of echlinux.

Copyright 2002 Jeff Pierce wd4nmq.

This software is covered by the included GNU Public License, GPL.

$Log$

****************************/ 

#include <stdio.h>
#include <stdlib.h>
#include <sys/ioctl.h>
#include <sys/stat.h>
#include <linux/soundcard.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <sys/ioctl.h>
#include <fcntl.h>
#include <unistd.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <netdb.h>
#include <errno.h>
#include <string.h>

#include "gsm.h"
#include "echolinux.h"
#include "echoGlobals.h"

#define SoundFileIn     "/dev/dsp"
#define SoundFileOut     "/dev/dsp"

#define RATE 8000
#define CHANNELS 1
#define SIZE 16

int audiofd;

gsm gsmh;

unsigned char  gsmBuff[33], tempLine[80], recvBuffer[2044];
unsigned short usbuff[700];
unsigned short seq;

short *sbuff, average;

struct gsmVoice_t voicePacket;

struct sockaddr_in destAddr, inAddr;
int inAudioSocket, outAudioSocket;
char *callsign = NULL;
int  leaveApp = 0, quit = 0, newConnect = 1;

struct stat infoStatus;
int  infoFile;
char *infoBuffer;
char echoLinuxDefaults[80];

/**************** read info file ***********/

int sendInfoFile(void){
  int count = 0, result;
  char *temp, line[80];

  strcpy(line, echoLinuxDefaults);
  strcat(line, "info.txt");

  infoFile = open(line, O_RDONLY);
  if(infoFile < 0){
    perror("Openning info file.");
    return(FALSE);
  }

  fstat(infoFile, &infoStatus);
  if(stat < 0){
    perror("Getting info file size.");
    close(infoFile);
    return(FALSE);
  }

  if(infoStatus.st_size <= 0){
    close(infoFile);
    return(FALSE);    
  }

  infoBuffer =(char *) malloc(infoStatus.st_size + 10);
  if(!infoBuffer){
    close(infoFile);
    return(FALSE);    
  }
  strcpy(&infoBuffer[0], "oNDATA\r");
  count = read(infoFile, &infoBuffer[7], infoStatus.st_size);
  if(count != infoStatus.st_size){
    close(infoFile);
    free(infoBuffer);
    return(FALSE);
  }
  count += 7;
  infoBuffer[count++] = 0x00;

  temp = infoBuffer;
  while(temp){
    temp = strchr(temp,'\n');
    if(temp){
      *temp = '\r';
      temp++;
    }
  }

  result = sendto(outAudioSocket,
		  infoBuffer,
		  count,
		  0,
		  (struct sockaddr *) &destAddr,
		  sizeof destAddr);
  
  
}

/****************************************/

int soundInput(void){

  // int arg, status;
  int arg, status;
  long frag_size  = 0x7FFF000B;

  audiofd = open(SoundFileIn, O_RDWR);
  if(audiofd < 0){
    perror(" opening audio input ");
    exit(1);
  }

  // printf("Opened /dev/audio fd = %d.\n", audiofd);

  if (ioctl(audiofd, SNDCTL_DSP_SETFRAGMENT, &frag_size) == -1) {
    perror("SNDCTL_DSP_SETFRAGMENT ioctl failed");          
  }


  arg = SIZE;
  status = ioctl(audiofd, SOUND_PCM_WRITE_BITS, &arg);
  if(status == -1)
    perror("SOUND_PCM_WRITE_BITS ioctl failed");
  if(arg != SIZE)
    perror("unable to set sample size");

  arg = CHANNELS;
  status =  ioctl(audiofd, SOUND_PCM_WRITE_CHANNELS, &arg);
  if(status == -1)
    perror("SOUND_PCM_WRITE_CHANNELS ioctl failed");
  if(arg != CHANNELS)
    perror("unable to set number of channels");

  arg = RATE;
  status = ioctl(audiofd, SOUND_PCM_WRITE_RATE, &arg);
  if(status == -1)
    perror("SOUND_PCM_WRITE_RATE ioctl failed");
  
  arg = AFMT_S16_LE; 
  status = ioctl(audiofd,  SOUND_PCM_SETFMT, &arg);
  if(status == -1)
    perror(" SOUND_PCM_SETFMT ioctl failed");
  
}

/****************** decodeNDATA ***************/

void decodeNDATA(char *buffer){
  char *ptr;

  raw_tty(FALSE);

  if(buffer[strlen(buffer)-1] != '\n')
     // || (buffer[strlen(buffer)-1] == '\r')){
    strcat(buffer, "\n");
     
  /*********
  if((buffer[strlen(buffer)-1] == '\n') && 
     (strncmp(&buffer[2], "CONF", 4) != 0) &&
     (buffer[2] != '\r')){
  ***********/

  if((strncmp(&buffer[2], "CONF", 4) != 0) &&
     (buffer[2] != '\r')){
    buffer[0] = CHAT;
    buffer[1] = ' ';    
    fputs(buffer, stdout); 
  }
  else{
    buffer[0] = INFO;
    buffer[1] = ' ';

    //    buffer[strlen(buffer)-1] = '\n';
    fputs(buffer, stdout);

  }
  raw_tty(TRUE);
}

/******************** Send typed data *****************/

void sendNDATA(char *ndata){

  char *databuf;
  int result;

  databuf = calloc(1,strlen(ndata)+30);
  strcpy(databuf, "oNDATA");
  if(callsign)
    strcat(databuf, callsign);
  strcat(databuf,">");
  strcat(databuf, ndata);
  if(databuf[strlen(databuf) - 1] == '\n')
    databuf[strlen(databuf) - 1] = 0x00;
  strcat(databuf, "\r\n");
  result = sendto(outAudioSocket,
		  databuf,
		  strlen(databuf)+1,
		  0,
		  (struct sockaddr *) &destAddr,
		  sizeof destAddr);


  free(databuf);
}

/**************** Handle data from stdin ***********/

int fromControl(void){
  int i;
  char c;
  char line[80];

  fgets(line, 80, stdin);
  fputs("Got a command.\n", stdin);
    if(line[0] == TOGGLE){
      quit = TRUE;
    } else if(line[0] == QUIT){
      quit = TRUE;
      leaveApp = TRUE;
    } else if(line[0] == CHAT)
      sendNDATA(&line[1]);
}

/******************* Audio sending routine **************/

int sendAudio(void){

  static short seq = 1;
  short count = 0, total = 0;
  short i, result, *pTemp, j;
  char c, *temp, line[20];
  fd_set readfds, testfds;
  int len_inet;

  long average;

  FD_ZERO(&readfds);

  raw_tty(1);
 
  line[0] = TRANSMIT;
  line[1] = '\n';
  write(STDOUT_FILENO, line, 2);

  soundInput();

  FD_SET(STDIN_FILENO, &readfds);
  FD_SET(audiofd, &readfds);
  FD_SET(inAudioSocket, &readfds);

  quit = FALSE;
  while(!quit){

    testfds = readfds;

    result = select(FD_SETSIZE, &testfds, NULL, NULL, NULL);

    if(result < 0){
      perror("select");
      raw_tty(FALSE);
      exit(1);
    }
   
    if(FD_ISSET(audiofd, &testfds)){
      count = read(audiofd, usbuff, 1280);
      if(count < 0){
	perror("reading /dev/dsp  ");
	raw_tty(0);
	close(audiofd);
      }
      average = 0;
      for(i=0;i<4;i++){
	temp = voicePacket.data;
	gsm_encode(gsmh, usbuff+(i*160), temp+(i*33));
      }
      for(j=0;j<640;j+=2){
	pTemp = &usbuff[j];
	average = average + abs(*pTemp);
      }
      average = average / 320;
      sprintf(line, "%C %d", STRENGTH, average);
      puts(line);
      voicePacket.seqNum = htons(seq++);
      result = sendto(outAudioSocket,
		      &voicePacket,
		      sizeof voicePacket,
		      0,
		      (struct sockaddr *) &destAddr,
		      sizeof destAddr);
      if(result < 0){
	perror("sendto");
	close(audiofd);
	raw_tty(0);
	exit(1);
      }
    }

    if(FD_ISSET(inAudioSocket, &testfds)){
      len_inet = sizeof inAddr;
      result = recvfrom(inAudioSocket,
			recvBuffer,
			2048,
			0,
			(struct sockaddr *)&inAddr,
			&len_inet);

      if(result < 0){
	perror("recvfrom(2) in sendAudio ");
	close(audiofd);
	raw_tty(FALSE);
	exit(1);
      }
      if(recvBuffer[0] != 0xc0){
	// puts("E got a NDATA packet.");
	if(strncmp(&recvBuffer[1], "NDATA", 5) == 0)
	  decodeNDATA(&recvBuffer[4]);
      }

    }

    if(FD_ISSET(STDIN_FILENO, &testfds)){
      fromControl();
    }
  }    

  close(audiofd);
  raw_tty(0);
}

/************ Audio Receiving Function *******/

int recvAudio(void){
  struct gsmVoice_t *voicePacket;
  fd_set readfds, testfds;
  short i, result, j, *pTemp;
  int len_inet;
  audio_buf_info info;
  unsigned char *temp;
  char c, line[20];
  int audioEffect;

  long average;

  FD_ZERO(&readfds);

  line[0] = RECEIVE;
  line[1] = '\n';
  write(STDOUT_FILENO, line, 2);

  soundInput();

  if(newConnect){
    strcpy(line, echoLinuxDefaults); 
    if(audioEffect = open(strcat(line, "connect.wav")
			  , O_RDONLY)){
      do{
	i = read(audioEffect, recvBuffer, 320);
	if(i)
	write(audiofd, recvBuffer, i); 
      }while(i == 320);
      ioctl(audiofd, SOUND_PCM_SYNC, 0);
      newConnect = 0;
    }
  }

  raw_tty(1);

  voicePacket = (struct gsmVoice_t *) recvBuffer;

  FD_SET(STDIN_FILENO, &readfds);
  FD_SET(inAudioSocket, &readfds);

  quit = FALSE;
  while(!quit){

    testfds = readfds;

    select(FD_SETSIZE, &testfds, NULL, NULL, NULL);

    len_inet = sizeof inAddr;

    if(FD_ISSET(inAudioSocket, &testfds)){
      result = recvfrom(inAudioSocket,
			recvBuffer,
			2048,
			0,
			(struct sockaddr *)&inAddr,
			&len_inet);

      if(result < 0){
	perror("recvfrom(2) in recvAudio");
	raw_tty(FALSE);
	exit(1);
      }
      if(recvBuffer[0] != 0xc0){
	if(strncmp(&recvBuffer[1], "NDATA", 5) == 0)
	  decodeNDATA(&recvBuffer[4]);
      }else{
	average = 0;
	for(i=0;i<4;i++){
	  temp = &(voicePacket->data);
	  gsm_decode(gsmh, temp+(i*33), sbuff);
	  ioctl(audiofd, SNDCTL_DSP_GETOSPACE, &info);
	  while(info.bytes < 320){
	    ioctl(audiofd, SNDCTL_DSP_GETOSPACE, &info);
	  }
	  write(audiofd, sbuff, 320);
	  for(j=0;j<640;j+=2){
	    pTemp = &sbuff[j];
	    average = average + abs(*pTemp);
	  }
	  average = average / 320;
	  sprintf(line, "%C %d", STRENGTH, average);
	  puts(line);
	}
      }
    }
    if(FD_ISSET(STDIN_FILENO, &testfds)){
      // strcpy(tempLine,"Data from stdin.\n");
      // write(STDOUT_FILENO, tempLine, strlen(tempLine));
      fromControl();
    }
  }

  raw_tty(0);
  close(audiofd);
}

/************ Main Program ************/

int main(int argc, char *argv[]){

  long total, count;
  int status, result, len_inet, i;
  audio_buf_info info;
  char c, commandLine[80], *home;

  sbuff = (short *) usbuff;

  if(argc >= 3)
    callsign = argv[2];

  if(setvbuf(stdin, NULL, _IOLBF, 0) != 0){
    perror("setvbuf stdin");
    exit(1);
  }

  if(setvbuf(stdout, NULL, _IOLBF, 0) != 0){
    perror("setvbuf stdout");
    exit(1);
  }

  home = getenv("HOME");
  strcpy(echoLinuxDefaults, home);
  strcat(echoLinuxDefaults, "/.echoLinux/");

  /***************** Make audio output socket ***************/

  memset(&destAddr, 0, sizeof destAddr);
  destAddr.sin_family = AF_INET;
  destAddr.sin_port = htons(PORT_BASE);
  destAddr.sin_addr.s_addr = inet_addr(argv[1]);

  if(destAddr.sin_addr.s_addr == INADDR_NONE){
    perror("bad address");
    exit(1);
  }

  outAudioSocket = socket(AF_INET, SOCK_DGRAM, 0);
  if(outAudioSocket == -1){
    perror("socket");
    exit(1);
  }

  /************** Make audio input socket **********/
  memset(&inAddr, 0, sizeof inAddr);
  inAddr.sin_family = AF_INET;
  inAddr.sin_port = htons(PORT_BASE);
  inAddr.sin_addr.s_addr = INADDR_ANY;

  inAudioSocket = socket(AF_INET, SOCK_DGRAM, 0);
  if(inAudioSocket== -1){
    perror("inAudioSocket");
    exit(1);
  }

  status = bind(inAudioSocket, (struct sockaddr *)&inAddr, sizeof inAddr);
  if(status == -1){
    perror("duplex-bind");
    exit(1);
  }

  /******************************************/

  gsmh = gsm_create();  
  voicePacket.version = 0xc0;
  voicePacket.pt = 0x03;
  voicePacket.time = htonl(0);
  voicePacket.ssrc = htonl(0);

  sendInfoFile();

  while(!leaveApp){
  if(!leaveApp)
    recvAudio();
  if(!leaveApp)
    sendAudio();
  }

}








